<?php

Class Sape
{
	private $xml_rpc_url = 'http://www.sape.ru/api_xmlrpc.php';
	
	public function Go($login, $password)
	{
		// Для сапы юзаем XML-RPC
		
		for ($i=0; $i<5; $i++) {
			//print '<br><br>попытка: ' . $i . ' ';
			// логинимся
			$xml = '<?xml version="1.0"?>
			<methodCall>
				<methodName>sape.login</methodName>
				<params>
					<param><value><string>' . $login . '</string></value></param>
					<param><value><string>' . $password . '</string></value></param>
				</params>
			</methodCall>';
			
			$fsock = new Fsock;
			$fsock->Send($this->xml_rpc_url, $xml, 'post', '', '', 'text/xml');
			$cookies = $fsock->GetCookies($fsock->response);
			
			// запрашиваем инфо о юзере
			$xml = '<?xml version="1.0"?>
			<methodCall>
				<methodName>sape.get_user</methodName>
			</methodCall>';
			
			$contents = trim($fsock->Send($this->xml_rpc_url, $xml, 'post', $cookies, '', 'text/xml'));
			preg_match('#<methodResponse>(.*?)</methodResponse>#is', $contents, $m);
			if (isset($m[0]) && !empty($m[0])) {
				$clean_contents = '<?xml version="1.0"?>' . $m[0];
				$xml = simplexml_load_string($clean_contents);
				if (isset($xml->fault->value->struct->member->name) && $xml->fault->value->struct->member->name == 'faultCode') {
					$balance = 'ERROR';
					// login failed
					continue;
				}
				else {
					$balance = 'ERROR';
					foreach ($xml->params->param->value->struct->member as $p) {
						//var_dump($p);
						if ($p->name == 'balance') {
							$balance = $p->value->double;
							break;
						}
					}
					if ($balance != 'ERROR') {
						break;
					}
				}
			}
			sleep(1);
		}
		
		if ($balance != 'ERROR') {
			$result = 'Баланс: <b>' . round($balance,2) . '</b> руб.';
			return($result);
		}
		else {
			return(false);
		}
	}
}

?>