<?php

include('inc/config.php');

$results = '<h1>Мухаха!</h1>';

foreach (glob("modules/*") as $filename) {
	$module = substr($filename,8);
	
	$_time = gettime();
	print 'Запускаем модуль ' . $module . '... ';
	
	// load config
	$config = file('modules/' . $module . '/config.txt');
	
	$title = trim($config[0]);
	$login = trim($config[1]);
	$password = trim($config[2]);
	$enabled = trim($config[3]);
	
	if (!$enabled) {
		print '<del>выключен</del>';
	}
	else {
		if (!file_exists('modules/' . $module . '/' . $module . '.php')) {
			print '<strong style="color:red;">нет модуля!</strong>';
		}
		else {
			include_once('modules/' . $module . '/' . $module . '.php');
			$mmodule = ucfirst($module);
			$obj = new $mmodule;
			
			$result = $obj->Go($login, $password);
			
			if (!$result) {
				print '<strong>НЕ ВОЗМОЖНО ПОЛУЧИТЬ РЕЗУЛЬТАТ!</strong>';
			}
			else {
				$results .= '<h2>' . $title . '</h2><p>' . $result . '</p>';
				print '<strong style="color:green;">цель получена</strong>';
			}
		}
	}
	
	print ' &mdash; ' . number_format((gettime()-$_time), 6, '.', ' ') . ' сек.<br />';
	
	flush();
	sleep(1);
}


/*
** Теперь отдами резульаты
*/

if ($cfg['doscreen']) {
	print $results;
}

if ($cfg['domail']) {
	$headers  = "MIME-Version: 1.0\n";
	$headers .= "From: {$cfg['from_name']} <{$cfg['from_mail']}>\n";
	$headers .= "Content-Type: text/html; charset=utf-8\n";
	$headers .= "X-Mailer: PHP/" . phpversion();

	$subject = "Результаты epsyl.moneyer от " . date("d.m.Y H:i");
	$subject = "=?utf-8?B?" . base64_encode($subject) . "?=";

	$mail_name = "=?utf-8?B?" . base64_encode($cfg['name']) . "?=";

	mail("{$mail_name} <{$cfg['mail']}>", $subject, $results, $headers);
}

print '<br />Завершили, можно покурить.';

?>